const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const service_types = sequelize.define(
    'service_types',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

signature_level: {
        type: DataTypes.ENUM,
      
      

        values: [

"simple",


"advanced",


"notary_required"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  service_types.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.service_types.hasMany(db.service_auth_policies, {
      as: 'service_auth_policies_service_type',
      foreignKey: {
          name: 'service_typeId',
      },
      constraints: false,
    });






    db.service_types.hasMany(db.workflow_definitions, {
      as: 'workflow_definitions_service_type',
      foreignKey: {
          name: 'service_typeId',
      },
      constraints: false,
    });




    db.service_types.hasMany(db.price_rules, {
      as: 'price_rules_service_type',
      foreignKey: {
          name: 'service_typeId',
      },
      constraints: false,
    });



    db.service_types.hasMany(db.contract_folders, {
      as: 'contract_folders_service_type',
      foreignKey: {
          name: 'service_typeId',
      },
      constraints: false,
    });

























//end loop



    db.service_types.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.service_types.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.service_types.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return service_types;
};


